//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forx-tsd.com"
#property link      "www.forx-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width3  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int    DeviationsPeriod = 14;
extern int    MaPeriod         = 14;
extern int    HighLowPeriod    = 5;
extern int    SumPeriod        = 3;
extern int    SmoothPeriod     = 3;
extern int    Price            = PRICE_CLOSE;
extern int    AtrPeriod        = 5;
extern double UpTreshold       = 90;
extern double DownTreshold     = 10;

//
//
//
//
//

double bufferUp[];
double bufferDn[];
double stoch[];
double atrstoch[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bufferUp);
   SetIndexBuffer(1,bufferDn);
   SetIndexBuffer(2,stoch);
   SetIndexBuffer(3,atrstoch);
         IndicatorShortName("TTI Stochastic extreme 2 ("+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][6];
#define _x1    0
#define _x3    1
#define _minx1 2
#define _maxx1 3
#define _minx3 4
#define _maxx3 5

//
//
//
//
//

int start()
{
   double alpha = 2.0 / (1.0+SmoothPeriod);
   int i,k,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
           
           

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double devs  = iStdDev(NULL,0,DeviationsPeriod,0,MODE_SMA,Price,i);
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      
         if (price>iMA(NULL,0,MaPeriod,0,MODE_SMA,Price,i))
               work[r][_x1] =  devs;
         else  work[r][_x1] = -devs;
      
         //
         //
         //
         //
         //
         
            work[r][_minx1] = work[r][_x1];
            work[r][_maxx1] = work[r][_x1];
         
               for (k=1; k<HighLowPeriod && (r-k)>=0; k++)
               {
                  work[r][_minx1] = MathMin(work[r][_minx1],work[r-k][_x1]);
                  work[r][_maxx1] = MathMax(work[r][_maxx1],work[r-k][_x1]);
               }

            double sum1 = work[r][_x1]   -work[r][_minx1];
            double sum2 = work[r][_maxx1]-work[r][_minx1];

               for (k=1; k<SumPeriod && (r-k)>=0; k++)
               {
                  sum1 += work[r-k][_x1]   -work[r-k][_minx1];
                  sum2 += work[r-k][_maxx1]-work[r-k][_minx1];
               }
                  
            if (sum2!=0)
                  double x2 = 100.0*sum1/sum2;
            else         x2 = 0;                                       
            stoch[i] = stoch[i+1]+alpha*(x2-stoch[i+1]);

         //
         //
         //
         //
         //
         
            work[r][_x3]    = work[r][_x1]*iATR(NULL,0,AtrPeriod,i);
            work[r][_minx3] = work[r][_x3];
            work[r][_maxx3] = work[r][_x3];
         
               for (k=1; k<HighLowPeriod && (r-k)>=0; k++)
               {
                  work[r][_minx3] = MathMin(work[r][_minx3],work[r-k][_x3]);
                  work[r][_maxx3] = MathMax(work[r][_maxx3],work[r-k][_x3]);
               }

            sum1 = work[r][_x3]   -work[r][_minx3];
            sum2 = work[r][_maxx3]-work[r][_minx3];

               for (k=1; k<SumPeriod && (r-k)>=0; k++)
               {
                  sum1 += work[r-k][_x3]   -work[r-k][_minx3];
                  sum2 += work[r-k][_maxx3]-work[r-k][_minx3];
               }
                  
            if (sum2!=0)
                  double x4 = 100.0*sum1/sum2;
            else         x4 = 0;                                       
            atrstoch[i] = atrstoch[i+1]+alpha*(x4-atrstoch[i+1]);
            

         //
         //
         //
         //
         //
                     
            bufferUp[i] = UpTreshold;  
            bufferDn[i] = DownTreshold;  
   }
   
   //
   //
   //
   //
   //
 
   return(0);
}

